
default persistent.mc_name = ""
default persistent.w_name = ""
default persistent.d_name = ""
default New_Game = False
default Renaming = False

define -2 gui.name_text_outlines = [ (3, "#000000F0", 0, 0) ]
define -2 gui.dialogue_text_outlines = [ (3, "#000000F0", 0, 0) ]


init -1:
    if hasattr(store, "g_textbox_transparency") == False:
        $ g_textbox_transparency = 100


init python:

    hardcoded = {}

    def hardcoded_names(text):
        def text_repl(t):
            if t.group(0).startswith("chris_name"): return "persistent.mc_name"
            elif t.group(0).startswith("chris"): return "[persistent.mc_name]"
            elif t.group(0).startswith("Chris"): return "[persistent.mc_name]"
            elif t.group(0).startswith("sandra"): return "[persistent.w_name]"
            elif t.group(0).startswith("Sandra"): return "[persistent.w_name]"
            elif t.group(0).startswith("emily"): return "[persistent.d_name]"
            elif t.group(0).startswith("Emily"): return "[persistent.d_name]"
        return hardcoded[text] if text in hardcoded else renpy.re.sub( r'(?:chris_name|chris|Chris|sandra|Sandra|emily|Emily)', text_repl, text )

    config.say_menu_text_filter = hardcoded_names

init 99:
    define chris = Character("[persistent.mc_name]")
    define sandra = Character("[persistent.w_name]")
    define emily = Character("[persistent.d_name]")

    python:
        config.label_overrides = { "start" : "start_override" }


#init 500 screen navigation():
screen navigation():

    vbox:
        style_prefix "navigation"

        xpos gui.navigation_xpos
        yalign 0.5

        spacing gui.navigation_spacing

        if main_menu:

            textbutton _("Start") action Start()

        else:

            #textbutton _("History") action ShowMenu("history")

            textbutton _("Save") action ShowMenu("save")

        textbutton _("Load") action ShowMenu("load")

        textbutton _("Preferences") action ShowMenu("preferences")

        if not _in_replay:

            textbutton _("Shaddy's Scene Replay") action [ui.callsinnewcontext("Set_Names"), SetVariable("Shaddy_Replay", True), ShowMenu("sceneReplay1")] text_style "shaddyTextButton2"

        if _in_replay:

            textbutton _("End Replay") action EndReplay(confirm=True)

        elif not main_menu:

            textbutton _("Main Menu") action MainMenu()


        if renpy.variant("pc"):

            ## The quit button is banned on iOS and unnecessary on Android and
            ## Web.
            null height 64
            textbutton _("Quit") action Quit(confirm=not main_menu)


init 500 screen preferences():

    tag menu
    ####Textbox transparency
    $ renpy.retain_after_load()
    ####

    use game_menu(_("Preferences"), scroll="viewport"):

        vbox:

            hbox:
                box_wrap True

                if renpy.variant("pc"):

                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")

                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")

                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                    textbutton _("Transitions") action InvertSelected(Preference("transitions", "toggle"))

            null height (4 * gui.pref_spacing)

            hbox:
                style_prefix "slider"
                box_wrap True

                vbox:

                    label _("Text Speed")

                    bar value Preference("text speed")

                    label _("Auto-Forward Time")

                    bar value Preference("auto-forward time")

                vbox:

                    if config.has_music:
                        label _("Music Volume")

                        hbox:
                            bar value Preference("music volume")

                    if config.has_sound:

                        label _("Sound Volume")

                        hbox:
                            bar value Preference("sound volume")

                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)


                    if config.has_voice:
                        label _("Voice Volume")

                        hbox:
                            bar value Preference("voice volume")

                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)

                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing

                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"

                vbox:
                    #label _("")
                    text _("ShaddyModda Additions") xcenter 0.4 style "shaddyTextBoxHeader"
                    hbox:
                        spacing -200
                        if not renpy.loadable("ShaddyMod/mod_A_patch.rpy"):
                            vbox:
                                label _("Names")
                                textbutton _("Change") action SetVariable("Renaming", True), [ui.callsinnewcontext("Set_Names")], Return()
                        else:
                            vbox:
                                label _("Names & Age")
                                textbutton _("Change") action SetVariable("Renaming", True), [ui.callsinnewcontext("Set_Names")], Return()

                        vbox:
                            label _("Text Size: %s" % (persistent.pref_text_size))
                            bar value FieldValue(object=persistent, field='pref_text_size', range=(gui.text_size * 2), max_is_zero=False, style=u'slider', offset=0, step=1) style "slider" xsize 400
                        vbox:
                            ### Textbox transparency
                            label _("Textbox Transparency")
                            #bar value VariableValue("g_textbox_transparency", 100) style "slider" xsize 350 #ysize 20
                            bar value VariableValue("g_textbox_transparency", 100) style "slider" xsize 400 #ysize 20
                            ####


default persistent.pref_text_size = gui.text_size

screen say(who, what):
    style_prefix "say"
    ###Textbox transparency
    $ l_alpha = 1 - float(g_textbox_transparency) / 100
    ###
    window:
        id "window"
        #######Textbox transparency
        background Image(im.Alpha("gui/textbox.png", l_alpha), xalign=0.5, yalign=1.0)
        ######
        if who is not None:

            window:
                id "namebox"
                style "namebox"
                text who id "who"
        if persistent.say_window_alpha < 0.6:
            text what id "what" size persistent.pref_text_size outlines [(2, "#000", 0, 0)]
        else:
            text what id "what" size persistent.pref_text_size outlines [(2, "#000", 0, 0)]



    ## If there's a side image, display it above the text. Do not display on the
    ## phone variant - there's no room.
    if not renpy.variant("small"):
        add SideImage() xalign 0.0 yalign 1.0


screen input(prompt):
    style_prefix "input"
    ###Textbox transparency
    $ l_alpha = 1 - float(g_textbox_transparency) / 100
    ###
    window:

        vbox:
            xalign gui.dialogue_text_xalign
            xpos gui.dialogue_xpos
            xsize gui.dialogue_width
            ypos gui.dialogue_ypos

            text prompt style "input_prompt" outlines [(3,"#000",1,1)]
            input id "input" outlines [(3,"#000",1,1)]
        ###Textbox transparency
        background Image(im.Alpha("gui/textbox.png", l_alpha), xalign=0.5, yalign=1.0)
        ###


label after_load:

    if hasattr(store, "g_textbox_transparency") == False:
        $ g_textbox_transparency = 50

    if g_textbox_transparency == 0:
        $ g_textbox_transparency = 50
    return


label start_override:
    $ New_Game = True

label Set_Names:

    if New_Game or Renaming or not persistent.galleryNameSet:
        scene image("images/ep2/001.webp") with fade
        $ persistent.mc_name = renpy.input("What is your name?", default="Chris").strip()
        $ chris_name = persistent.mc_name

        scene image("images/ep1/004.webp") with fade
        $ persistent.w_name = renpy.input("My wife, the love of my life. What is her name?", default="Sandra").strip()

        scene image("images/ep1/034.webp") with fade
        $ persistent.d_name = renpy.input("This is our [daughter]. What is her name?", default="Emily").strip()
        if renpy.loadable("ShaddyMod/mod_A_patch.rpy"):
            call mod_patch_vars

        $ persistent.galleryNameSet = True

    else:
        pass

    if New_Game:
        $ New_Game = False
        call episode1
        call episode2
    elif Shaddy_Replay:
        $ Shaddy_Replay = False
        #call screen sceneReplay1
    else:
        $ Renaming = False
        #return

style shaddyTextBoxHeader is text:
    size 60
    color "#0ed6f9"
    font "shaddyMod/212 Leahlee Sans.otf"
